"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function getLogger(component) {
    return __awaiter(this, void 0, void 0, function* () {
        const Rabbit = (yield Promise.resolve().then(() => require('./rabbit'))).default;
        const logger = level => (...args) => {
            if (Rabbit.INSTANCE && Rabbit.INSTANCE.listenerCount('log') > 0) {
                return void Rabbit.INSTANCE.emit('log', level, ...args);
            }
            console.log(`[${level}] ${component}`, ...args);
        };
        return {
            debug: logger('debug'),
            warn: logger('warn'),
            info: logger('info'),
            error: logger('erro')
        };
    });
}
exports.default = getLogger;
//# sourceMappingURL=get-logger.js.map