"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function getLogger(component) {
    const logger = (level) => (...args) => __awaiter(this, void 0, void 0, function* () {
        const rabbit = (yield Promise.resolve().then(() => require('./rabbit'))).default;
        if (rabbit.INSTANCE && rabbit.INSTANCE.listenerCount('log') > 0) {
            return void rabbit.INSTANCE.emit('log', component, level, ...args);
        }
        console.log(`[${level}] ${component}`, ...args);
    });
    return {
        debug: logger('debug'),
        warn: logger('warn'),
        info: logger('info'),
        error: logger('error'),
        trace: logger('trace'),
    };
}
exports.default = getLogger;
//# sourceMappingURL=logger.js.map